How to Attach Reserved IPs on a Vultr Bare Metal Instance

Updated on 16 July, 2026

A guide for assigning and managing persistent IP addresses on Vultr Bare Metal servers


Reserved IP addresses enable you to reserve a specific public IP address you can attach to instances. You can attach multiple reserved IPs on a single instance to enable new network interfaces.

Follow this guide to attach reserved IPs on a Vultr Bare Metal instance using the Vultr Console, API, CLI, or Terraform.

  • Vultr Console
  • Vultr API
  • Vultr CLI
  • Terraform
  1. Navigate to Network and click Reserved IPs.
  2. Click your target reserved IP to open its management page.
  3. Click the link icon next to Attached Instance to open the Attach Reserved IP to Instance panel.
  4. Select your target Bare Metal instance from the list.
  5. Click Attach Reserved IP to apply the reserved IP to your Bare Metal instance.
  6. Restart the Bare Metal instance from its management page to apply the new IP configuration.
  1. Send a GET request to the List Bare Metal Instances endpoint and note the target instance's ID in your output.

    console
    $ curl "https://api.vultr.com/v2/bare-metals" \
      -X GET \
      -H "Authorization: Bearer ${VULTR_API_KEY}"
    
  2. Send a GET request to the List Reserved IPs endpoint and note the target reserved IP's ID in your output.

    console
    $ curl "https://api.vultr.com/v2/reserved-ips" \
       -X GET \
       -H "Authorization: Bearer ${VULTR_API_KEY}"
    
  3. Send a POST request to the Attach Reserved IP endpoint to attach a new reserved IP to the instance.

    console
    $ curl "https://api.vultr.com/v2/reserved-ips/{reserved-ip}/attach" \
      -X POST \
      -H "Authorization: Bearer ${VULTR_API_KEY}" \
      -H "Content-Type: application/json" \
      --data '{
        "instance_id" : "<instance-id>"
      }'
    

    A successful request returns an HTTP 204 No Content response.

  4. Send a GET request to the Get Reserved IP endpoint to verify the instance_id field matches your Bare Metal instance.

    console
    $ curl "https://api.vultr.com/v2/reserved-ips/{reserved-ip}" \
      -X GET \
      -H "Authorization: Bearer ${VULTR_API_KEY}"
    
  5. Send a POST request to the Reboot Bare Metal Instance endpoint to restart the instance and apply the new IP configuration.

    console
    $ curl "https://api.vultr.com/v2/bare-metals/{baremetal-id}/reboot" \
      -X POST \
      -H "Authorization: Bearer ${VULTR_API_KEY}"
    
  1. List all reserved IPs in your Vultr account and note the target reserved IP's ID.

    console
    $ vultr-cli reserved-ip list
    
  2. List all Bare Metal instances in your Vultr account and note the target instance's ID.

    console
    $ vultr-cli bare-metal list
    
  3. Attach the reserved IP to the Bare Metal instance.

    console
    $ vultr-cli reserved-ip attach <reserved-ip-id> --instance-id <baremetal-instance-id>
    
  4. Restart the Bare Metal instance to apply the new IP configuration.

    console
    $ vultr-cli bare-metal reboot <baremetal-instance-id>
    
  1. Open your Terraform configuration for the existing Bare Metal instance.

  2. Update the reserved_ip_id value in the Bare Metal resource to the ID of the target reserved IP.

    terraform
    resource "vultr_bare_metal_server" "bm1" {
        # ...existing fields (region, plan, label, etc.)
    
        reserved_ip_id = "your-reserved-ip-id"
    }
    

    Or create a new reserved IP in Terraform and attach it to the Bare Metal instance:

    terraform
    resource "vultr_reserved_ip" "bm1_ip" {
        region  = "del"
        ip_type = "v4"
        label   = "bm1-reserved-ip"
    }
    
    resource "vultr_bare_metal_server" "bm1" {
        # ...existing fields (region, plan, os_id, label, etc.)
    
        reserved_ip_id = vultr_reserved_ip.bm1_ip.id
    }
    
  3. Apply the configuration and observe the following output:

    Apply complete! Resources: 1 added, 0 changed, 0 destroyed.

    Terraform does not automatically restart the instance. Restart the Bare Metal instance from the Vultr Console, API, or CLI to apply the new IP configuration.

Comments